import { Component, State, Watch, Prop, h } from '@stencil/core';
import { getSvgContent, iconContent } from '../../utils/request';
export class FIcons {
  constructor() {
    this.group = 'default';
    this.size = '20';
  }
  async componentWillLoad() {
    this.sym = Symbol.for('@facilio/icons/config');
    await this.loadIcon();
  }
  async loadIcon() {
    var _a;
    // give the cdn url or url based on the init function
    let cdnUrl = 'https://static.facilio.com/icons/svg/';
    let baseUrl = ((_a = window[this.sym]) === null || _a === void 0 ? void 0 : _a.baseUrl) ? window[this.sym].baseURL : cdnUrl;
    const url = `${baseUrl}${this.group}/${this.name}.svg`;
    if (iconContent.has(url)) {
      this.svgContent = iconContent.get(url);
    }
    else {
      await getSvgContent(url).then(() => (this.svgContent = iconContent.get(url)));
    }
    let styledSvg = `<svg class="${this.iconClass ? this.iconClass : 'icon'}" style="height:${this.size}px; width: ${this.size}px; fill: ${this.color}"`;
    styledSvg = this.svgContent.replace(/<svg/, styledSvg);
    this.icon = styledSvg;
  }
  render() {
    return h("div", { class: "svg-container", innerHTML: this.icon });
  }
  static get is() { return "f-icons"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["f-icons.css"]
  }; }
  static get styleUrls() { return {
    "$": ["f-icons.css"]
  }; }
  static get properties() { return {
    "name": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "name",
      "reflect": false
    },
    "group": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "group",
      "reflect": false,
      "defaultValue": "'default'"
    },
    "size": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "size",
      "reflect": false,
      "defaultValue": "'20'"
    },
    "color": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "color",
      "reflect": false
    }
  }; }
  static get states() { return {
    "svgContent": {},
    "iconClass": {},
    "icon": {},
    "baseURL": {},
    "sym": {}
  }; }
  static get watchers() { return [{
      "propName": "name",
      "methodName": "componentWillLoad"
    }, {
      "propName": "icon",
      "methodName": "componentWillLoad"
    }]; }
}
